#pragma once

#include "CoreMinimal.h"
#include "InteractionDefinition.h"
#include "Engine/CollisionProfile.h"
#include "Templates/SubclassOf.h"
#include "PassageEnterInteraction.generated.h"

class UStatusEffect;
class APassage;
class ADBDPlayer;

UCLASS(Blueprintable, EditInlineNew, meta=(BlueprintSpawnableComponent))
class DBDGAMEPLAY_API UPassageEnterInteraction : public UInteractionDefinition
{
	GENERATED_BODY()

public:
	DECLARE_DYNAMIC_MULTICAST_DELEGATE_OneParam(FCosmeticPassageInteractionEventDelegate, ADBDPlayer*, player);

public:
	UPROPERTY(BlueprintReadWrite, BlueprintAssignable)
	FCosmeticPassageInteractionEventDelegate _cosmetic_onPassageInteractionStarted;

protected:
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	float _enterMovePhaseSeconds;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	float _transitionPhaseSeconds;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	float _exitMovePhaseSeconds;

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	float _targetSpringArmLength;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	float _enterSequenceMoveDistance;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	float _exitSequenceMoveDistance;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	float _stuckInPassageDistance;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FCollisionProfileName _collisionProfileForSequence;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FCollisionProfileName _collisionProfileOnExit;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	TSubclassOf<UStatusEffect> _preventRunningStatusEffect;

public:
	UFUNCTION(BlueprintPure)
	APassage* GetOwningPassage() const;

public:
	UPassageEnterInteraction();
};

FORCEINLINE uint32 GetTypeHash(const UPassageEnterInteraction) { return 0; }
